///home/berryj/link/bin/genMethods "-g" "-t" "BinGraph" "-r" "MBinGraph" "-I" "LINK/graph/BinGraph.h" "-y" "display_graph" "-w" "free_graph" "-d" "graph" "-f" "__binGraph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/BinGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graph(SCM, SCM, int);
void free_graph(SCM);

typedef BinGraph _BinGraph;

#define _BinGraphDATA(x) ((BinGraph*) (EXTDATA(x)))
#define _BinGraphIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<BinGraph >::type))
#define _BinGraphISNT_DATA(x) (!_BinGraphIS_DATA(x))

#define _BinGraphCXX_DATA(x) (*(BinGraph*) (EXTDATA(VAL(x))))
#define _BinGraphCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<BinGraph >::type))
#define _BinGraphCXX_ISNT_DATA(x) (!_BinGraphCXX_IS_DATA(x))


PRIMITIVE STk_init___binGraph()
{
	Wrapper<_BinGraph>::type = STk_new_CXXwrapper_id(
			Wrapper<_BinGraph>::name, 
			Wrapper<MBinGraph >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graph,
			(void (*)(SCM x))0,
			(void (*)(SCM x))free_graph);
	Tcl_InitHashTable(&Register<_BinGraph>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra__binGraphMethods(void);

PRIMITIVE STk_init_methods___binGraph()
{
	genExtra__binGraphMethods();
	return UNDEFINED;
}
